"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
require("./SwipeableButton.css");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var slider = /*#__PURE__*/_react["default"].createRef();
var container = /*#__PURE__*/_react["default"].createRef();
var isTouchDevice = navigator.maxTouchPoints > 0;
var SwipeableButton = exports["default"] = /*#__PURE__*/function (_Component) {
  _inherits(SwipeableButton, _Component);
  function SwipeableButton() {
    var _this;
    _classCallCheck(this, SwipeableButton);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _callSuper(this, SwipeableButton, [].concat(args));
    _defineProperty(_assertThisInitialized(_this), "state", {
      unlocked: false // Initialize unlocked state
    });
    _defineProperty(_assertThisInitialized(_this), "onDrag", function (e) {
      if (_this.state.unlocked) {
        return;
      }
      if (_this.isDragging) {
        var clientX = isTouchDevice ? e.touches[0].clientX : e.clientX;
        _this.sliderLeft = Math.min(Math.max(0, clientX - _this.startX), _this.containerWidth);
        _this.updateSliderStyle();
      }
    });
    _defineProperty(_assertThisInitialized(_this), "updateSliderStyle", function () {
      if (_this.state.unlocked) return;
      slider.current.style.left = "".concat(_this.sliderLeft + 50, "px");
    });
    _defineProperty(_assertThisInitialized(_this), "stopDrag", function () {
      if (_this.state.unlocked) return;
      if (_this.isDragging) {
        _this.isDragging = false;
        if (_this.sliderLeft > _this.containerWidth * 0.9) {
          _this.sliderLeft = _this.containerWidth;
          if (_this.props.onSuccess) {
            _this.props.onSuccess();
            _this.onSuccess();
          }
        } else {
          _this.sliderLeft = 0;
          if (_this.props.onFailure) {
            _this.props.onFailure();
          }
        }
        _this.updateSliderStyle();
      }
    });
    _defineProperty(_assertThisInitialized(_this), "startDrag", function (e) {
      if (_this.state.unlocked) return;
      _this.isDragging = true;
      _this.startX = isTouchDevice ? e.touches[0].clientX : e.clientX;
    });
    _defineProperty(_assertThisInitialized(_this), "onSuccess", function () {
      container.current.style.width = "".concat(container.current.clientWidth, "px");
      _this.setState({
        unlocked: true
      });
    });
    _defineProperty(_assertThisInitialized(_this), "getText", function () {
      return _this.state.unlocked ? _this.props.text_unlocked || 'UNLOCKED' : _this.props.text || 'SLIDE';
    });
    _defineProperty(_assertThisInitialized(_this), "reset", function () {
      if (_this.state.unlocked) return;
      _this.setState({
        unlocked: false
      }, function () {
        _this.sliderLeft = 0;
        _this.updateSliderStyle();
      });
    });
    return _this;
  }
  _createClass(SwipeableButton, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.containerWidth = container.current.clientWidth - 50;
      if (isTouchDevice) {
        document.addEventListener('touchmove', this.onDrag);
        document.addEventListener('touchend', this.stopDrag);
      } else {
        document.addEventListener('mousemove', this.onDrag);
        document.addEventListener('mouseup', this.stopDrag);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      // Remove event listeners when the component is unmounted
      if (isTouchDevice) {
        document.removeEventListener('touchmove', this.onDrag);
        document.removeEventListener('touchend', this.stopDrag);
      } else {
        document.removeEventListener('mousemove', this.onDrag);
        document.removeEventListener('mouseup', this.stopDrag);
      }
    }
  }, {
    key: "render",
    value: function render() {
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "ReactSwipeButton"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: 'rsbContainer ' + (this.state.unlocked ? 'rsbContainerUnlocked' : ''),
        ref: container
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "rsbcSlider",
        ref: slider,
        onMouseDown: this.startDrag,
        style: {
          background: this.props.color
        },
        onTouchStart: this.startDrag
      }, /*#__PURE__*/_react["default"].createElement("span", {
        className: "rsbcSliderText"
      }, this.getText()), /*#__PURE__*/_react["default"].createElement("span", {
        className: "rsbcSliderArrow"
      }), /*#__PURE__*/_react["default"].createElement("span", {
        className: "rsbcSliderCircle",
        style: {
          background: this.props.color
        }
      })), /*#__PURE__*/_react["default"].createElement("div", {
        className: "rsbcText"
      }, this.getText())));
    }
  }]);
  return SwipeableButton;
}(_react.Component);